#!/bin/bash

# Category : Communication & Collaboration Tools
# Description : Mastodon - Decentralized Social Network (c/u/s/r/i):

installMastodon()
{
    local config_variables="$1"

    if [[ "$mastodon" == *[cCtTuUsSrRiI]* ]]; then
        dockerConfigSetupToContainer silent mastodon;
        local app_name=$CFG_MASTODON_APP_NAME
		initializeAppVariables $app_name;
    fi

    if [[ "$mastodon" == *[cC]* ]]; then
        editAppConfig $app_name;
    fi

    if [[ "$mastodon" == *[uU]* ]]; then
        dockerUninstallApp $app_name;
    fi

    if [[ "$mastodon" == *[sS]* ]]; then
        dockerComposeDown $app_name;
    fi

    if [[ "$mastodon" == *[rR]* ]]; then
        dockerComposeRestart $app_name;
    fi

    if [[ "$mastodon" == *[iI]* ]]; then
        isHeader "Install $app_name"

		((menu_number++))
        echo ""
        echo "---- $menu_number. Setting up install folder and config file for $app_name."
        echo ""

        dockerConfigSetupToContainer "loud" "$app_name" "install" "$config_variables";
        isSuccessful "Install folders and Config files have been setup for $app_name."

		((menu_number++))
        echo ""
        echo "---- $menu_number. Setting up the $app_name docker-compose.yml file."
        echo ""

        dockerComposeSetupFile $app_name;

		((menu_number++))
        echo ""
        echo "---- $menu_number. Updating file permissions before starting."
        echo ""

		fixPermissionsBeforeStart $app_name;

		((menu_number++))
        echo ""
        echo "---- $menu_number. Running the docker-compose.yml to install and start $app_name"
        echo ""

		dockerComposeUpdateAndStartApp $app_name install;

        ((menu_number++))
        echo ""
        echo "---- $menu_number. Running Application specific updates (if required)"
        echo ""

        appUpdateSpecifics $app_name;

		((menu_number++))
        echo ""
        echo "---- $menu_number. Running Headscale setup (if required)"
        echo ""

		setupHeadscale $app_name;

		((menu_number++))
		echo ""
        echo "---- $menu_number. Adding $app_name to the Apps Database table."
        echo ""

		databaseInstallApp $app_name;

		((menu_number++))
		echo ""
		echo "---- $menu_number. Updating WebUI config file."
		echo ""

		webuiContainerSetup $app_name install;

		((menu_number++))
		echo ""
		echo "---- $menu_number. You can find $app_name files at $containers_dir$app_name"
        echo ""
        echo "    You can now navigate to your $app_name service using any of the options below : "
        echo ""

        menuShowFinalMessages $app_name;

		menu_number=0
        #sleep 3s
        cd
    fi
    mastodon=n
}
